//---------------------------------------------------------------------------

#ifndef SignalCfgH
#define SignalCfgH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Grids.hpp>
#include <ValEdit.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <vector>
//---------------------------------------------------------------------------

class TfrmSignalConfig : public TForm
{
__published:	// IDE-managed Components
	TPanel *pnlBottom;
	TPanel *pnlDetailView;
	TPanel *pnlTop;
	TButton *btnStart;
	TButton *btnStop;
	TLabel *Label1;
	TButton *btnSetWave;
	TLabel *Label2;
	TLabel *Label3;
	TEdit *edDacFreq;
	TEdit *edDacRealFreq;
	TLabel *Label4;
	TLabel *Label5;
	TLabel *Label6;
	TButton *btnUpdateFreq;
	TButton *btnFreq1pp;
	TButton *btnFreq1pm;
	TButton *btnFreq10pp;
	TButton *btnFreq10pm;
	TMainMenu *MainMenu1;
	TMenuItem *File1;
	TMenuItem *miOpenJson;
	TMenuItem *miSaveJson;
	TMenuItem *miLoadCsvShape;
	TScrollBox *scrollBox;
	TImage *image;
	TLabel *lblShapeSamples;
	TButton *btnClearPlot;
	TOpenDialog *openDialog;
	TSaveDialog *saveDialog;
	TPaintBox *pictboxVertScale;
	TButton *btnStandardShapes;
	TStatusBar *StatusBar;
	void __fastcall btnStartClick(TObject *Sender);
	void __fastcall btnStopClick(TObject *Sender);
	void __fastcall btnSetWaveClick(TObject *Sender);
	void __fastcall edDacFreqChange(TObject *Sender);
	void __fastcall btnUpdateFreqClick(TObject *Sender);
	void __fastcall btnFreq1ppClick(TObject *Sender);
	void __fastcall btnFreq1pmClick(TObject *Sender);
	void __fastcall btnFreq10ppClick(TObject *Sender);
	void __fastcall btnFreq10pmClick(TObject *Sender);
	void __fastcall imageMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall imageMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall imageMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall btnClearPlotClick(TObject *Sender);
	void __fastcall miSaveJsonClick(TObject *Sender);
	void __fastcall miOpenJsonClick(TObject *Sender);
	void __fastcall pictboxVertScalePaint(TObject *Sender);
	void __fastcall btnStandardShapesClick(TObject *Sender);
	void __fastcall imageMouseLeave(TObject *Sender);
private:	// User declarations
	bool running;
	unsigned short STM32_prescaler;
	unsigned int STM32_reload;
	float reqFreq;
	float realFreq;
	void SetNearestRealFreq(float freq);
	void UpdateFreq(void);
	void UpdateShape(void);

	bool mouseDown;
	int startX, startY;

	std::vector<unsigned char> samples;

	void AddSamplesPoint(int x, int y);
	void AddSamplesArea(int x1, int y1, int x2, int y2);
	inline unsigned char PlotYToVal(int Y)
	{
		return 255-Y;
	}
	inline int ValToPlotY(unsigned char val)
	{
    	return 255-val;
	}
	void UpdateSamplesInfo(void);
public:		// User declarations
	__fastcall TfrmSignalConfig(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmSignalConfig *frmSignalConfig;
//---------------------------------------------------------------------------
#endif
